# OsiXprSolverInterface Class Reference

XPRESS-MP Solver Interface. More...

`#include <OsiXprSolverInterface.hpp>`

Inheritance diagram for OsiXprSolverInterface:
[legend]
Collaboration diagram for OsiXprSolverInterface:
[legend]

List of all members.

## Public Member Functions
virtual void | setObjSense (double s)
| Set objective function sense (1 for min (default), -1 for max,).
virtual void | setColSolution (const double *colsol)
| Set the primal solution column values.
virtual void | setRowPrice (const double *rowprice)
| Set dual solution vector.
Solve methods
virtual void | initialSolve ()
| Solve initial LP relaxation.
virtual void | resolve ()
| Resolve an LP relaxation after problem modification.
virtual void | branchAndBound ()
| Invoke solver's built-in enumeration algorithm.
Parameter set/get methods
The set methods return true if the parameter was set to the given value, false otherwise. There can be various reasons for failure: the given parameter is not applicable for the solver (e.g., refactorization frequency for the volume algorithm), the parameter is not yet implemented for the solver or simply the value of the parameter is out of the range the solver accepts. If a parameter setting call returns false check the details of your solver. The get methods return true if the given parameter is applicable for the solver and is implemented. In this case the value of the parameter is returned in the second argument. Otherwise they return false.
bool | setIntParam (OsiIntParam key, int value)
| Set an integer parameter.
bool | setDblParam (OsiDblParam key, double value)
| Set a double parameter.
bool | setStrParam (OsiStrParam key, const std::string &value)
| Set a string parameter.
bool | getIntParam (OsiIntParam key, int &value) const
| Get an integer parameter.
bool | getDblParam (OsiDblParam key, double &value) const
| Get a double parameter.
bool | getStrParam (OsiStrParam key, std::string &value) const
| Get a string parameter.
void | setMipStart (bool value)
bool | getMipStart () const
Methods returning info on how the solution process terminated
virtual bool | isAbandoned () const
| Are there a numerical difficulties?
virtual bool | isProvenOptimal () const
| Is optimality proven?
virtual bool | isProvenPrimalInfeasible () const
| Is primal infeasiblity proven?
virtual bool | isProvenDualInfeasible () const
| Is dual infeasiblity proven?
virtual bool | isPrimalObjectiveLimitReached () const
| Is the given primal objective limit reached?
virtual bool | isDualObjectiveLimitReached () const
| Is the given dual objective limit reached?
virtual bool | isIterationLimitReached () const
| Iteration limit reached?
WarmStart related methods
CoinWarmStart * | getEmptyWarmStart () const
| Get empty warm start object.
virtual CoinWarmStart * | getWarmStart () const
| Get warmstarting information.
virtual bool | setWarmStart (const CoinWarmStart *warmstart)
| Set warmstarting information.
Hotstart related methods (primarily used in strong branching). <br>
The user can create a hotstart (a snapshot) of the optimization process then reoptimize over and over again always starting from there. NOTE: between hotstarted optimizations only bound changes are allowed.
virtual void | markHotStart ()
| Create a hotstart point of the optimization process.
virtual void | solveFromHotStart ()
| Optimize starting from the hotstart.
virtual void | unmarkHotStart ()
| Delete the snapshot.
Methods related to querying the input data
virtual int | getNumCols () const
| Get number of columns.
virtual int | getNumRows () const
| Get number of rows.
virtual int | getNumElements () const
| Get number of nonzero elements.
virtual const double * | getColLower () const
| Get pointer to array[getNumCols()] of column lower bounds.
virtual const double * | getColUpper () const
| Get pointer to array[getNumCols()] of column upper bounds.
virtual const char * | getRowSense () const
| Get pointer to array[getNumRows()] of row constraint senses.
virtual const double * | getRightHandSide () const
| Get pointer to array[getNumRows()] of rows right-hand sides.
virtual const double * | getRowRange () const
| Get pointer to array[getNumRows()] of row ranges.
virtual const double * | getRowLower () const
| Get pointer to array[getNumRows()] of row lower bounds.
virtual const double * | getRowUpper () const
| Get pointer to array[getNumRows()] of row upper bounds.
virtual const double * | getObjCoefficients () const
| Get pointer to array[getNumCols()] of objective function coefficients.
virtual double | getObjSense () const
| Get objective function sense (1 for min (default), -1 for max).
virtual bool | isContinuous (int colIndex) const
| Return true if variable is continuous.
virtual const CoinPackedMatrix * | getMatrixByRow () const
| Get pointer to row-wise copy of matrix.
virtual const CoinPackedMatrix * | getMatrixByCol () const
| Get pointer to column-wise copy of matrix.
virtual double | getInfinity () const
| Get solver's value for infinity.
Methods related to querying the solution
virtual const double * | getColSolution () const
| Get pointer to array[getNumCols()] of primal solution vector.
virtual const double * | getRowPrice () const
| Get pointer to array[getNumRows()] of dual prices.
virtual const double * | getReducedCost () const
| Get a pointer to array[getNumCols()] of reduced costs.
virtual const double * | getRowActivity () const
| Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.
virtual double | getObjValue () const
| Get objective function value.
virtual int | getIterationCount () const
| Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.
virtual std::vector< double * > | getDualRays (int maxNumRays, bool fullRay=false) const
| Get as many dual rays as the solver can provide.
virtual std::vector< double * > | getPrimalRays (int maxNumRays) const
| Get as many primal rays as the solver can provide.
Changing bounds on variables and constraints
virtual void | setObjCoeff (int elementIndex, double elementValue)
| Set an objective function coefficient.
virtual void | setColLower (int elementIndex, double elementValue)
| Set a single column lower bound Use -COIN_DBL_MAX for -infinity.
virtual void | setColUpper (int elementIndex, double elementValue)
| Set a single column upper bound Use COIN_DBL_MAX for infinity.
virtual void | setColBounds (int elementIndex, double lower, double upper)
| Set a single column lower and upper bound The default implementation just invokes setColLower() and setColUpper().
virtual void | setColSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of columns simultaneously The default implementation just invokes setColLower() and setColUpper() over and over again.
virtual void | setRowLower (int elementIndex, double elementValue)
| Set a single row lower bound Use -COIN_DBL_MAX for -infinity.
virtual void | setRowUpper (int elementIndex, double elementValue)
| Set a single row upper bound Use COIN_DBL_MAX for infinity.
virtual void | setRowBounds (int elementIndex, double lower, double upper)
| Set a single row lower and upper bound The default implementation just invokes setRowLower() and setRowUpper().
virtual void | setRowType (int index, char sense, double rightHandSide, double range)
| Set the type of a single row .
virtual void | setRowSetBounds (const int *indexFirst, const int *indexLast, const double *boundList)
| Set the bounds on a number of rows simultaneously The default implementation just invokes setRowLower() and setRowUpper() over and over again.
virtual void | setRowSetTypes (const int *indexFirst, const int *indexLast, const char *senseList, const double *rhsList, const double *rangeList)
| Set the type of a number of rows simultaneously The default implementation just invokes setRowType() over and over again.
Integrality related changing methods
virtual void | setContinuous (int index)
| Set the index-th variable to be a continuous variable.
virtual void | setInteger (int index)
| Set the index-th variable to be an integer variable.
virtual void | setContinuous (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be continuous variables.
virtual void | setInteger (const int *indices, int len)
| Set the variables listed in indices (which is of length len) to be integer variables.
Methods to expand a problem.<br>
Note that if a column is added then by default it will correspond to a continuous variable.
virtual void | addCol (const CoinPackedVectorBase &vec, const double collb, const double colub, const double obj)
| Add a column (primal variable) to the problem.
virtual void | addCols (const int numcols, const CoinPackedVectorBase *const *cols, const double *collb, const double *colub, const double *obj)
| Add a set of columns (primal variables) to the problem.
virtual void | deleteCols (const int num, const int *colIndices)
| Remove a set of columns (primal variables) from the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const double rowlb, const double rowub)
| Add a row (constraint) to the problem.
virtual void | addRow (const CoinPackedVectorBase &vec, const char rowsen, const double rowrhs, const double rowrng)
| Add a row (constraint) to the problem.
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const double *rowlb, const double *rowub)
virtual void | addRows (const int numrows, const CoinPackedVectorBase *const *rows, const char *rowsen, const double *rowrhs, const double *rowrng)
| Add a set of rows (constraints) to the problem.
virtual void | deleteRows (const int num, const int *rowIndices)
| Delete a set of rows (constraints) from the problem.
Methods to input a problem
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, double *&rowlb, double *&rowub)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).
virtual void | loadProblem (const CoinPackedMatrix &matrix, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | assignProblem (CoinPackedMatrix *&matrix, double *&collb, double *&colub, double *&obj, char *&rowsen, double *&rowrhs, double *&rowrng)
| Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const double *rowlb, const double *rowub)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual void | loadProblem (const int numcols, const int numrows, const int *start, const int *index, const double *value, const double *collb, const double *colub, const double *obj, const char *rowsen, const double *rowrhs, const double *rowrng)
| Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).
virtual int | readMps (const char *filename, const char *extension="mps")
| Read an mps file from the given filename.
virtual void | writeMps (const char *filename, const char *extension="mps", double objSense=0.0) const
| Write the problem into an mps file of the given filename.
Message handling
void | passInMessageHandler (CoinMessageHandler *handler)
| Pass in a message handler It is the client's responsibility to destroy a message handler installed by this routine; it will not be destroyed when the solver interface is destroyed.
Constructors and destructors
| OsiXprSolverInterface (int newrows=50, int newnz=100)
| Default Constructor.
virtual OsiSolverInterface * | clone (bool copyData=true) const
| Clone.
| OsiXprSolverInterface (const OsiXprSolverInterface &)
| Copy constructor.
OsiXprSolverInterface & | operator= (const OsiXprSolverInterface &rhs)
| Assignment operator.
virtual | ~OsiXprSolverInterface ()
| Destructor.
## Static Public Member Functions
static int | version ()
| Return XPRESS-MP Version number.
## Protected Member Functions
Protected methods
virtual void | applyRowCut (const OsiRowCut &rc)
| Apply a row cut. Return true if cut was applied.
virtual void | applyColCut (const OsiColCut &cc)
| Apply a column cut (bound adjustment).
## Private Member Functions
Private methods
void | gutsOfCopy (const OsiXprSolverInterface &source)
| The real work of a copy constructor (used by copy and assignment).
void | gutsOfConstructor ()
| The real work of a constructor (used by construct and assignment).
void | gutsOfDestructor ()
| The real work of a destructor (used by copy and assignment).
void | freeSolution ()
| Destroy cached copy of solution data (whenever it changes).
void | freeCachedResults ()
| Destroy cached copies of problem and solution data (whenever they change).
int | getNumIntVars () const
| Number of integer variables in the problem.
Methods to support for XPRESS-MP multiple matrix facility
void | getVarTypes () const
| Build cached copy of variable types.
void | activateMe () const
| Save the current problem in XPRESS (if necessary) and make this problem current (restore if necessary).
bool | isDataLoaded () const
| Save and restore are necessary if there is data associated with this problem.
## Private Attributes
bool | domipstart
| Whether to pass a column solution to XPRESS before starting MIP solve (loadmipsol).
Data to support for XPRESS-MP multiple matrix facility
XPRSprob | prob_
| XPRESS problem name (should be unique for each saved problem).
std::string | xprProbname_
| XPRESS problem name (should be unique for each saved problem).
Cached copies of XPRESS-MP problem data
CoinPackedMatrix * | matrixByRow_
| Pointer to row-wise copy of problem matrix coefficients.
CoinPackedMatrix * | matrixByCol_
| Pointer to row-wise copy of problem matrix coefficients.
double * | colupper_
| Pointer to dense vector of structural variable upper bounds.
double * | collower_
| Pointer to dense vector of structural variable lower bounds.
double * | rowupper_
| Pointer to dense vector of slack variable upper bounds.
double * | rowlower_
| Pointer to dense vector of slack variable lower bounds.
char * | rowsense_
| Pointer to dense vector of row sense indicators.
double * | rhs_
| Pointer to dense vector of row right-hand side values.
double * | rowrange_
| Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).
double * | objcoeffs_
| Pointer to dense vector of objective coefficients.
double | objsense_
| Sense of objective (1 for min; -1 for max).
double * | colsol_
| Pointer to dense vector of primal structural variable values.
double * | rowsol_
| Pointer to dense vector of primal slack variable values.
double * | rowact_
| Pointer to dense vector of primal slack variable values.
double * | rowprice_
| Pointer to dense vector of dual row variable values.
double * | colprice_
| Pointer to dense vector of dual column variable values.
int * | ivarind_
| Pointer to list of indices of XPRESS "global" variables.
char * | ivartype_
| Pointer to list of global variable types:.
char * | vartype_
| Pointer to dense vector of variable types (as above, or 'C' for continuous).
bool | lastsolvewasmip
| Indicates whether the last solve was for a MIP or an LP.
## Static Private Attributes
Private static class data
static const char * | logFileName_
| Name of the logfile.
static FILE * | logFilePtr_
| The FILE* to the logfile.
static unsigned int | numInstances_
| Number of live problem instances.
static unsigned int | osiSerial_
| Counts calls to incrementInstanceCounter().
## Friends
void | OsiXprSolverInterfaceUnitTest (const std::string &mpsDir, const std::string &netlibDir)
| A function that tests the methods in the OsiXprSolverInterface class.
## Log File
static int | iXprCallCount_
| Get logfile FILE *.
static FILE * | getLogFilePtr ()
| Get logfile FILE *.
static void | setLogFileName (const char *filename)
| Set logfile name.
## Static instance counter methods
XPRSprob | getLpPtr ()
| Return a pointer to the XPRESS problem.
static void | incrementInstanceCounter ()
| XPRESS has a context that must be created prior to all other XPRESS calls.
static void | decrementInstanceCounter ()
| XPRESS has a context that should be deleted after XPRESS calls.
static unsigned int | getNumInstances ()
| Return the number of instances of instantiated objects using XPRESS services.

## Detailed Description

XPRESS-MP Solver Interface.

Instantiation of OsiSolverInterface for XPRESS-MP

Definition at line 21 of file OsiXprSolverInterface.hpp.

## Constructor & Destructor Documentation

OsiXprSolverInterface::OsiXprSolverInterface | ( | int | newrows = `50`,
|  | int | newnz = `100` |
| ) |  |  |

Default Constructor.

OsiXprSolverInterface::OsiXprSolverInterface | ( | const OsiXprSolverInterface & |  | ) |

Copy constructor.

virtual OsiXprSolverInterface::~OsiXprSolverInterface | ( |  | ) | `[virtual]`

Destructor.

## Member Function Documentation

virtual void OsiXprSolverInterface::initialSolve | ( |  | ) | `[virtual]`

Solve initial LP relaxation.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::resolve | ( |  | ) | `[virtual]`

Resolve an LP relaxation after problem modification.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::branchAndBound | ( |  | ) | `[virtual]`

Invoke solver's built-in enumeration algorithm.

Implements OsiSolverInterface.

bool OsiXprSolverInterface::setIntParam | ( | OsiIntParam | key,
|  | int | value |
| ) |  |  | `[virtual]`

Set an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiXprSolverInterface::setDblParam | ( | OsiDblParam | key,
|  | double | value |
| ) |  |  | `[virtual]`

Set a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiXprSolverInterface::setStrParam | ( | OsiStrParam | key,
|  | const std::string & | value |
| ) |  |  | `[virtual]`

Set a string parameter.

Reimplemented from OsiSolverInterface.

bool OsiXprSolverInterface::getIntParam | ( | OsiIntParam | key,
|  | int & | value |
| ) |  |  | const`[virtual]`

Get an integer parameter.

Reimplemented from OsiSolverInterface.

bool OsiXprSolverInterface::getDblParam | ( | OsiDblParam | key,
|  | double & | value |
| ) |  |  | const`[virtual]`

Get a double parameter.

Reimplemented from OsiSolverInterface.

bool OsiXprSolverInterface::getStrParam | ( | OsiStrParam | key,
|  | std::string & | value |
| ) |  |  | const`[virtual]`

Get a string parameter.

Reimplemented from OsiSolverInterface.

void OsiXprSolverInterface::setMipStart | ( | bool | value | ) | `[inline]`

Definition at line 64 of file OsiXprSolverInterface.hpp.

bool OsiXprSolverInterface::getMipStart | ( |  | ) | const`[inline]`

Definition at line 66 of file OsiXprSolverInterface.hpp.

virtual bool OsiXprSolverInterface::isAbandoned | ( |  | ) | const`[virtual]`

Are there a numerical difficulties?

Implements OsiSolverInterface.

virtual bool OsiXprSolverInterface::isProvenOptimal | ( |  | ) | const`[virtual]`

Is optimality proven?

Implements OsiSolverInterface.

virtual bool OsiXprSolverInterface::isProvenPrimalInfeasible | ( |  | ) | const`[virtual]`

Is primal infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiXprSolverInterface::isProvenDualInfeasible | ( |  | ) | const`[virtual]`

Is dual infeasiblity proven?

Implements OsiSolverInterface.

virtual bool OsiXprSolverInterface::isPrimalObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given primal objective limit reached?

Reimplemented from OsiSolverInterface.

virtual bool OsiXprSolverInterface::isDualObjectiveLimitReached | ( |  | ) | const`[virtual]`

Is the given dual objective limit reached?

Reimplemented from OsiSolverInterface.

virtual bool OsiXprSolverInterface::isIterationLimitReached | ( |  | ) | const`[virtual]`

Iteration limit reached?

Implements OsiSolverInterface.

CoinWarmStart* OsiXprSolverInterface::getEmptyWarmStart | ( |  | ) | const`[virtual]`

Get empty warm start object.

Implements OsiSolverInterface.

virtual CoinWarmStart* OsiXprSolverInterface::getWarmStart | ( |  | ) | const`[virtual]`

Get warmstarting information.

Implements OsiSolverInterface.

virtual bool OsiXprSolverInterface::setWarmStart | ( | const CoinWarmStart * | warmstart | ) | `[virtual]`

Set warmstarting information.

Return true/false depending on whether the warmstart information was accepted or not.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::markHotStart | ( |  | ) | `[virtual]`

Create a hotstart point of the optimization process.

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::solveFromHotStart | ( |  | ) | `[virtual]`

Optimize starting from the hotstart.

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::unmarkHotStart | ( |  | ) | `[virtual]`

Delete the snapshot.

Reimplemented from OsiSolverInterface.

virtual int OsiXprSolverInterface::getNumCols | ( |  | ) | const`[virtual]`

Get number of columns.

Implements OsiSolverInterface.

virtual int OsiXprSolverInterface::getNumRows | ( |  | ) | const`[virtual]`

Get number of rows.

Implements OsiSolverInterface.

virtual int OsiXprSolverInterface::getNumElements | ( |  | ) | const`[virtual]`

Get number of nonzero elements.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getColLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getColUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of column upper bounds.

Implements OsiSolverInterface.

virtual const char* OsiXprSolverInterface::getRowSense | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row constraint senses.

- 'L': <= constraint
- 'E': = constraint
- 'G': >= constraint
- 'R': ranged constraint
- 'N': free constraint

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getRightHandSide | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of rows right-hand sides.

- if rowsense()[i] == 'L' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'G' then rhs()[i] == rowlower()[i]
- if rowsense()[i] == 'R' then rhs()[i] == rowupper()[i]
- if rowsense()[i] == 'N' then rhs()[i] == 0.0

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getRowRange | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row ranges.

- if rowsense()[i] == 'R' then rowrange()[i] == rowupper()[i] - rowlower()[i]
- if rowsense()[i] != 'R' then rowrange()[i] is 0.0

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getRowLower | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row lower bounds.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getRowUpper | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row upper bounds.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getObjCoefficients | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of objective function coefficients.

Implements OsiSolverInterface.

virtual double OsiXprSolverInterface::getObjSense | ( |  | ) | const`[virtual]`

Get objective function sense (1 for min (default), -1 for max).

Implements OsiSolverInterface.

virtual bool OsiXprSolverInterface::isContinuous | ( | int | colIndex | ) | const`[virtual]`

Return true if variable is continuous.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiXprSolverInterface::getMatrixByRow | ( |  | ) | const`[virtual]`

Get pointer to row-wise copy of matrix.

Implements OsiSolverInterface.

virtual const CoinPackedMatrix* OsiXprSolverInterface::getMatrixByCol | ( |  | ) | const`[virtual]`

Get pointer to column-wise copy of matrix.

Implements OsiSolverInterface.

virtual double OsiXprSolverInterface::getInfinity | ( |  | ) | const`[virtual]`

Get solver's value for infinity.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getColSolution | ( |  | ) | const`[virtual]`

Get pointer to array[getNumCols()] of primal solution vector.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getRowPrice | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of dual prices.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getReducedCost | ( |  | ) | const`[virtual]`

Get a pointer to array[getNumCols()] of reduced costs.

Implements OsiSolverInterface.

virtual const double* OsiXprSolverInterface::getRowActivity | ( |  | ) | const`[virtual]`

Get pointer to array[getNumRows()] of row activity levels (constraint matrix times the solution vector.

Implements OsiSolverInterface.

virtual double OsiXprSolverInterface::getObjValue | ( |  | ) | const`[virtual]`

Get objective function value.

Implements OsiSolverInterface.

virtual int OsiXprSolverInterface::getIterationCount | ( |  | ) | const`[virtual]`

Get how many iterations it took to solve the problem (whatever "iteration" mean to the solver.

Implements OsiSolverInterface.

virtual std::vector<double*> OsiXprSolverInterface::getDualRays | ( | int | maxNumRays,
|  | bool | fullRay = `false` |
| ) |  |  | const`[virtual]`

Get as many dual rays as the solver can provide.

(In case of proven primal infeasibility there should be at least one.)

The first getNumRows() ray components will always be associated with the row duals (as returned by getRowPrice()). If `fullRay` is true, the final getNumCols() entries will correspond to the ray components associated with the nonbasic variables. If the full ray is requested and the method cannot provide it, it will throw an exception.

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumRows() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual std::vector<double*> OsiXprSolverInterface::getPrimalRays | ( | int | maxNumRays | ) | const`[virtual]`

Get as many primal rays as the solver can provide.

(In case of proven dual infeasibility there should be at least one.)

NOTE for implementers of solver interfaces:
The double pointers in the vector should point to arrays of length getNumCols() and they should be allocated via new[].

NOTE for users of solver interfaces:
It is the user's responsibility to free the double pointers in the vector using delete[].

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setObjCoeff | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set an objective function coefficient.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setColLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column lower bound
Use -COIN_DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setColUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single column upper bound
Use COIN_DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setColBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[virtual]`

Set a single column lower and upper bound
The default implementation just invokes setColLower() and setColUpper().

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::setColSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a number of columns simultaneously
The default implementation just invokes setColLower() and setColUpper() over and over again.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the variables whose either bound changes
  | boundList | the new lower/upper bound pairs for the variables

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::setRowLower | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row lower bound
Use -COIN_DBL_MAX for -infinity.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setRowUpper | ( | int | elementIndex,
|  | double | elementValue |
| ) |  |  | `[virtual]`

Set a single row upper bound
Use COIN_DBL_MAX for infinity.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setRowBounds | ( | int | elementIndex,
|  | double | lower,
|  | double | upper |
| ) |  |  | `[virtual]`

Set a single row lower and upper bound
The default implementation just invokes setRowLower() and setRowUpper().

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::setRowType | ( | int | index,
|  | char | sense,
|  | double | rightHandSide,
|  | double | range |
| ) |  |  | `[virtual]`

Set the type of a single row
.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setRowSetBounds | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const double * | boundList |
| ) |  |  | `[virtual]`

Set the bounds on a number of rows simultaneously
The default implementation just invokes setRowLower() and setRowUpper() over and over again.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the constraints whose either bound changes
  | boundList | the new lower/upper bound pairs for the constraints

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::setRowSetTypes | ( | const int * | indexFirst,
|  | const int * | indexLast,
|  | const char * | senseList,
|  | const double * | rhsList,
|  | const double * | rangeList |
| ) |  |  | `[virtual]`

Set the type of a number of rows simultaneously
The default implementation just invokes setRowType() over and over again.

Parameters:

  | indexFirst,indexLast | pointers to the beginning and after the end of the array of the indices of the constraints whose any characteristics changes
  | senseList | the new senses
  | rhsList | the new right hand sides
  | rangeList | the new ranges

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::setContinuous | ( | int | index | ) | `[virtual]`

Set the index-th variable to be a continuous variable.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setInteger | ( | int | index | ) | `[virtual]`

Set the index-th variable to be an integer variable.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setContinuous | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be continuous variables.

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::setInteger | ( | const int * | indices,
|  | int | len |
| ) |  |  | `[virtual]`

Set the variables listed in indices (which is of length len) to be integer variables.

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::setObjSense | ( | double | s | ) | `[virtual]`

Set objective function sense (1 for min (default), -1 for max,).

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setColSolution | ( | const double * | colsol | ) | `[virtual]`

Set the primal solution column values.

colsol[numcols()] is an array of values of the problem column variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of colsol() until changed by another call to setColsol() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::setRowPrice | ( | const double * | rowprice | ) | `[virtual]`

Set dual solution vector.

rowprice[numrows()] is an array of values of the problem row dual variables. These values are copied to memory owned by the solver object or the solver. They will be returned as the result of rowprice() until changed by another call to setRowprice() or by a call to any solver routine. Whether the solver makes use of the solution in any way is solver-dependent.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::addCol | ( | const CoinPackedVectorBase & | vec,
|  | const double | collb,
|  | const double | colub,
|  | const double | obj |
| ) |  |  | `[virtual]`

Add a column (primal variable) to the problem.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::addCols | ( | const int | numcols,
|  | const CoinPackedVectorBase *const * | cols,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj |
| ) |  |  | `[virtual]`

Add a set of columns (primal variables) to the problem.

The default implementation simply makes repeated calls to addCol().

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::deleteCols | ( | const int | num,
|  | const int * | colIndices |
| ) |  |  | `[virtual]`

Remove a set of columns (primal variables) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted variables are nonbasic.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const double | rowlb,
|  | const double | rowub |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::addRow | ( | const CoinPackedVectorBase & | vec,
|  | const char | rowsen,
|  | const double | rowrhs,
|  | const double | rowrng |
| ) |  |  | `[virtual]`

Add a row (constraint) to the problem.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::addRows | ( | const int | numrows,
|  | const CoinPackedVectorBase *const * | rows,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Add a set of rows (constraints) to the problem.

The default implementation simply makes repeated calls to addRow().

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::deleteRows | ( | const int | num,
|  | const int * | rowIndices |
| ) |  |  | `[virtual]`

Delete a set of rows (constraints) from the problem.

The solver interface for a basis-oriented solver will maintain valid warm start information if all deleted rows are loose.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by lower and upper bounds).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `rowub`: all rows have upper bound infinity
- `rowlb`: all rows have lower bound -infinity
- `obj`: all variables have 0 objective coefficient

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | double *& | rowlb,
|  | double *& | rowub |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by lower and upper bounds).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::loadProblem | ( | const CoinPackedMatrix & | matrix,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by copying the arguments (the constraints on the rows are given by sense/rhs/range triplets).

If a pointer is 0 then the following values are the default:

- `colub`: all columns have upper bound infinity
- `collb`: all columns have lower bound 0
- `obj`: all variables have 0 objective coefficient
- `rowsen`: all rows are >=
- `rowrhs`: all right hand sides are 0
- `rowrng`: 0 for the ranged rows

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::assignProblem | ( | CoinPackedMatrix *& | matrix,
|  | double *& | collb,
|  | double *& | colub,
|  | double *& | obj,
|  | char *& | rowsen,
|  | double *& | rowrhs,
|  | double *& | rowrng |
| ) |  |  | `[virtual]`

Load in an problem by assuming ownership of the arguments (the constraints on the rows are given by sense/rhs/range triplets).

For default values see the previous method.
WARNING: The arguments passed to this method will be freed using the C++ `delete` and `delete[]` functions.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const double * | rowlb,
|  | const double * | rowub |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::loadProblem | ( | const int | numcols,
|  | const int | numrows,
|  | const int * | start,
|  | const int * | index,
|  | const double * | value,
|  | const double * | collb,
|  | const double * | colub,
|  | const double * | obj,
|  | const char * | rowsen,
|  | const double * | rowrhs,
|  | const double * | rowrng |
| ) |  |  | `[virtual]`

Just like the other loadProblem() methods except that the matrix is given in a standard column major ordered format (without gaps).

Implements OsiSolverInterface.

virtual int OsiXprSolverInterface::readMps | ( | const char * | filename,
|  | const char * | extension = `"mps"` |
| ) |  |  | `[virtual]`

Read an mps file from the given filename.

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::writeMps | ( | const char * | filename,
|  | const char * | extension = `"mps"`,
|  | double | objSense = `0.0` |
| ) |  |  | const`[virtual]`

Write the problem into an mps file of the given filename.

If objSense is non zero then -1.0 forces the code to write a maximization objective and +1.0 to write a minimization one. If 0.0 then solver can do what it wants

Implements OsiSolverInterface.

void OsiXprSolverInterface::passInMessageHandler | ( | CoinMessageHandler * | handler | ) | `[virtual]`

Pass in a message handler It is the client's responsibility to destroy a message handler installed by this routine; it will not be destroyed when the solver interface is destroyed.

Reimplemented from OsiSolverInterface.

static void OsiXprSolverInterface::incrementInstanceCounter | ( |  | ) | `[static]`

XPRESS has a context that must be created prior to all other XPRESS calls.

This method:

- Increments by 1 the number of uses of the XPRESS environment.
- Creates the XPRESS context when the number of uses is changed to 1 from 0.

static void OsiXprSolverInterface::decrementInstanceCounter | ( |  | ) | `[static]`

XPRESS has a context that should be deleted after XPRESS calls.

This method:

- Decrements by 1 the number of uses of the XPRESS environment.
- Deletes the XPRESS context when the number of uses is change to 0 from 1.

static unsigned int OsiXprSolverInterface::getNumInstances | ( |  | ) | `[static]`

Return the number of instances of instantiated objects using XPRESS services.

XPRSprob OsiXprSolverInterface::getLpPtr | ( |  | ) | `[inline]`

Return a pointer to the XPRESS problem.

Definition at line 606 of file OsiXprSolverInterface.hpp.

static int OsiXprSolverInterface::version | ( |  | ) | `[static]`

Return XPRESS-MP Version number.

static FILE* OsiXprSolverInterface::getLogFilePtr | ( |  | ) | `[static]`

Get logfile FILE *.

static void OsiXprSolverInterface::setLogFileName | ( | const char * | filename | ) | `[static]`

Set logfile name.

The logfile is an attempt to capture the calls to Xpress functions for debugging.

virtual OsiSolverInterface* OsiXprSolverInterface::clone | ( | bool | copyData = `true` | ) | const`[virtual]`

Clone.

Implements OsiSolverInterface.

OsiXprSolverInterface& OsiXprSolverInterface::operator= | ( | const OsiXprSolverInterface & | rhs | ) |

Assignment operator.

Reimplemented from OsiSolverInterface.

virtual void OsiXprSolverInterface::applyRowCut | ( | const OsiRowCut & | rc | ) | `[protected, virtual]`

Apply a row cut. Return true if cut was applied.

Implements OsiSolverInterface.

virtual void OsiXprSolverInterface::applyColCut | ( | const OsiColCut & | cc | ) | `[protected, virtual]`

Apply a column cut (bound adjustment).

Return true if cut was applied.

Implements OsiSolverInterface.

void OsiXprSolverInterface::gutsOfCopy | ( | const OsiXprSolverInterface & | source | ) | `[private]`

The real work of a copy constructor (used by copy and assignment).

void OsiXprSolverInterface::gutsOfConstructor | ( |  | ) | `[private]`

The real work of a constructor (used by construct and assignment).

void OsiXprSolverInterface::gutsOfDestructor | ( |  | ) | `[private]`

The real work of a destructor (used by copy and assignment).

void OsiXprSolverInterface::freeSolution | ( |  | ) | `[private]`

Destroy cached copy of solution data (whenever it changes).

void OsiXprSolverInterface::freeCachedResults | ( |  | ) | `[private]`

Destroy cached copies of problem and solution data (whenever they change).

int OsiXprSolverInterface::getNumIntVars | ( |  | ) | const`[private]`

Number of integer variables in the problem.

void OsiXprSolverInterface::getVarTypes | ( |  | ) | const`[private]`

Build cached copy of variable types.

void OsiXprSolverInterface::activateMe | ( |  | ) | const`[private]`

Save the current problem in XPRESS (if necessary) and make this problem current (restore if necessary).

bool OsiXprSolverInterface::isDataLoaded | ( |  | ) | const`[private]`

Save and restore are necessary if there is data associated with this problem.

Also, queries to a problem with no data should respond sensibly; XPRESS query results are undefined.

## Friends And Related Function Documentation

void OsiXprSolverInterfaceUnitTest | ( | const std::string & | mpsDir,
|  | const std::string & | netlibDir |
| ) |  |  | `[friend]`

A function that tests the methods in the OsiXprSolverInterface class.

## Member Data Documentation

int OsiXprSolverInterface::iXprCallCount_`[static]`

Get logfile FILE *.

Definition at line 614 of file OsiXprSolverInterface.hpp.

const char* OsiXprSolverInterface::logFileName_`[static, private]`

Name of the logfile.

Definition at line 661 of file OsiXprSolverInterface.hpp.

FILE* OsiXprSolverInterface::logFilePtr_`[static, private]`

The FILE* to the logfile.

Definition at line 664 of file OsiXprSolverInterface.hpp.

unsigned int OsiXprSolverInterface::numInstances_`[static, private]`

Number of live problem instances.

Definition at line 667 of file OsiXprSolverInterface.hpp.

unsigned int OsiXprSolverInterface::osiSerial_`[static, private]`

Counts calls to incrementInstanceCounter().

Definition at line 670 of file OsiXprSolverInterface.hpp.

XPRSprob OsiXprSolverInterface::prob_`[mutable, private]`

XPRESS problem name (should be unique for each saved problem).

Definition at line 719 of file OsiXprSolverInterface.hpp.

std::string OsiXprSolverInterface::xprProbname_`[mutable, private]`

XPRESS problem name (should be unique for each saved problem).

Definition at line 722 of file OsiXprSolverInterface.hpp.

CoinPackedMatrix* OsiXprSolverInterface::matrixByRow_`[mutable, private]`

Pointer to row-wise copy of problem matrix coefficients.

Note that XPRESS keeps the objective row in the problem matrix, so row indices and counts are adjusted accordingly.

Definition at line 732 of file OsiXprSolverInterface.hpp.

CoinPackedMatrix* OsiXprSolverInterface::matrixByCol_`[mutable, private]`

Pointer to row-wise copy of problem matrix coefficients.

Note that XPRESS keeps the objective row in the problem matrix, so row indices and counts are adjusted accordingly.

Definition at line 733 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::colupper_`[mutable, private]`

Pointer to dense vector of structural variable upper bounds.

Definition at line 736 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::collower_`[mutable, private]`

Pointer to dense vector of structural variable lower bounds.

Definition at line 739 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::rowupper_`[mutable, private]`

Pointer to dense vector of slack variable upper bounds.

Definition at line 742 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::rowlower_`[mutable, private]`

Pointer to dense vector of slack variable lower bounds.

Definition at line 745 of file OsiXprSolverInterface.hpp.

char* OsiXprSolverInterface::rowsense_`[mutable, private]`

Pointer to dense vector of row sense indicators.

Definition at line 748 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::rhs_`[mutable, private]`

Pointer to dense vector of row right-hand side values.

Definition at line 751 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::rowrange_`[mutable, private]`

Pointer to dense vector of slack upper bounds for range constraints (undefined for non-range rows).

Definition at line 756 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::objcoeffs_`[mutable, private]`

Pointer to dense vector of objective coefficients.

Definition at line 759 of file OsiXprSolverInterface.hpp.

double OsiXprSolverInterface::objsense_`[mutable, private]`

Sense of objective (1 for min; -1 for max).

Definition at line 762 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::colsol_`[mutable, private]`

Pointer to dense vector of primal structural variable values.

Definition at line 765 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::rowsol_`[mutable, private]`

Pointer to dense vector of primal slack variable values.

Definition at line 768 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::rowact_`[mutable, private]`

Pointer to dense vector of primal slack variable values.

Definition at line 771 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::rowprice_`[mutable, private]`

Pointer to dense vector of dual row variable values.

Definition at line 774 of file OsiXprSolverInterface.hpp.

double* OsiXprSolverInterface::colprice_`[mutable, private]`

Pointer to dense vector of dual column variable values.

Definition at line 777 of file OsiXprSolverInterface.hpp.

int* OsiXprSolverInterface::ivarind_`[mutable, private]`

Pointer to list of indices of XPRESS "global" variables.

Definition at line 780 of file OsiXprSolverInterface.hpp.

char* OsiXprSolverInterface::ivartype_`[mutable, private]`

Pointer to list of global variable types:.

- 'B': binary variable
- 'I': general integer variable (but might have 0-1 bounds)
- 'P': partial integer variable (not currently supported)
- 'S': sem-continuous variable (not currently supported)

Definition at line 790 of file OsiXprSolverInterface.hpp.

char* OsiXprSolverInterface::vartype_`[mutable, private]`

Pointer to dense vector of variable types (as above, or 'C' for continuous).

Definition at line 795 of file OsiXprSolverInterface.hpp.

bool OsiXprSolverInterface::lastsolvewasmip`[mutable, private]`

Indicates whether the last solve was for a MIP or an LP.

Definition at line 798 of file OsiXprSolverInterface.hpp.

bool OsiXprSolverInterface::domipstart`[private]`

Whether to pass a column solution to XPRESS before starting MIP solve (loadmipsol).

Definition at line 803 of file OsiXprSolverInterface.hpp.

The documentation for this class was generated from the following file:

- /home/coin/svn-release/Smi-0.93.1/Osi/src/OsiXpr/OsiXprSolverInterface.hpp